import java.awt.Image;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.MediaTracker;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.net.URL;
import java.awt.TextArea;
import java.awt.Color;
import java.awt.Font;
import java.awt.Cursor;
import java.awt.Toolkit;
import java.awt.Point;
import java.awt.Scrollbar;
import java.util.Timer;
import java.util.TimerTask;
//import java.awt.FileDialog;
import java.io.FilenameFilter;
import java.awt.Dimension;
import java.awt.image.BufferedImage;
import javax.swing.SwingUtilities;


class SpritePrims  extends Primitives {

  Sprite who;
  Splash splashframe;


  static String[] primlist={
    "createframe", "4", "findsprite", "2", "newsprite", "3",
    "newshape", "1", "talkto", "1", "ask", "2", "who", "0", "setxy", "2",
    "xcor", "0", "ycor", "0", "pixcolor", "3",
    "setshape", "1", "shape", "0", "setlayer", "1",
    "hide", "0", "show", "0", "shown", "0", "outsiderect", "1", "rect", "0", "spritelist", "0",
    "shift?", "0", "control?", "0", "setlabel", "4", "labelwidth" , "1",
    "newdynamicshape", "2", "drawinshape", "4", "paintinshape", "3", "clearshape", "1", "ptinshape?", "3", "shapew", "1",
    "shapeh", "1", "writeinshape", "5", "newmask", "2", "drawinmask", "5",  "clearmask", "1",
    "settitle", "1",
    "framesize" , "0", "validate", "0", "requestfocus", "0", "shapesize", "1",
    "dolater", "1", "shapefile?", "1", "setheading", "1", "heading", "0",
    "shadowshape", "2", "showsplash", "3", "hidesplash", "0", "showframe", "1", "hideframe", "1",
    "clickcount", "0", "setappicon", "1",
  };

  public String[] primlist(){return primlist;}

  public Object dispatch(int offset, Object[] args, LContext lc){
    synchronized((lc.canvas==null) ? ((Object)lc) : ((Object) lc.canvas)){
      switch(offset){
      case 0: return prim_createframe(args[0], args[1], args[2], args[3], lc);
      case 1: return prim_findsprite(args[0], args[1], lc);
      case 2: return prim_newsprite(args[0], args[1], args[2], lc);
      case 3: return prim_newshape(args[0], lc);
      case 4: return prim_talkto(args[0], lc);
      case 5: return prim_ask(args[0], args[1], lc);
      case 6: return prim_who(lc);
      case 7: return prim_setxy(args[0], args[1], lc);
      case 8: return new Double(who.rect.x);        //xcor
      case 9: return new Double(who.rect.y);        // ycor
      case 10: return prim_pixcolor(args[0], args[1], args[2], lc);
      case 11: who.setshape((Shape)args[0]); return null;
      case 12: return who.shape;
      case 13: who.setlayer(Logo.anInt(args[0], lc)); return null;
      case 14: who.hide(); return null;
      case 15: who.show(); return null;
      case 16: return prim_shown(lc);
      case 17: return prim_outsiderect(args[0], lc);
      case 18: return prim_rect(lc);
      case 19: return prim_spritelist (lc);
      case 20: return new Boolean(lc.shiftdown);
      case 21: return new Boolean(lc.controldown);
      case 22: return prim_setlabel(args[0], args[1], args[2], args[3], lc);
      case 23: return prim_labelwidth(args[0], lc);
      case 24: return prim_newdynamicshape (args[0], args[1], lc);
      case 25: return prim_drawinshape (args[0], args[1], args[2], args[3], lc);
      case 26: return prim_paintinshape (args[0], args[1], args[2], lc);
      case 27: return prim_clearshape (args[0], lc);
      case 28: return prim_ptinshape(args[0], args[1], args[2], lc);
      case 29: return prim_shapew (args[0], lc);
      case 30: return prim_shapeh (args[0], lc);
      case 31: return prim_writeinshape (args[0], args[1], args[2], args[3], args[4], lc);
      case 32: return prim_newmask(args[0], args[1], lc);
      case 33: return prim_drawinmask(args[0], args[1], args[2], args[3], args[4], lc);
      case 34: return prim_clearmask(args[0], lc);
      case 35: return prim_settitle(args[0], lc);
      case 36: return prim_framesize(lc);
      case 37: return prim_validate( lc);
      case 38: return prim_requestfocus( lc);
      case 39: return prim_shapesize(args[0], lc);
      case 40: return prim_dolater(args[0], lc);
      case 41: return prim_shapefile(args[0], lc);
      case 42: return prim_setheading(args[0], lc);
      case 43: return new Double(who.heading);
      case 44: return prim_shadowshape(args[0], args[1], lc);
      case 45: return prim_showsplash(args[0], args[1], args[2], lc);
      case 46: return prim_hidesplash(lc);
      case 47: return prim_showframe(args[0], lc);
      case 48: return prim_hideframe(args[0], lc);
      case 49: return new Integer(lc.clickcount);
      case 50: return prim_setappicon(args[0], lc);
        }
      return null;
    }
  }

  Object prim_createframe(Object arg1, Object arg2, Object arg3, Object arg4, LContext lc){
    int left = Logo.anInt(arg1, lc), top = Logo.anInt(arg2, lc);
    int width = Logo.anInt(arg3, lc), height = Logo.anInt(arg4, lc);
    if(lc.frame!=null) lc.frame.dispose();
    lc.frame = new SpriteFrame(width, height, lc);
    lc.canvas  = new SpriteCanvas(width, height, lc);
    lc.frame.canvas = lc.canvas;
    lc.panel = lc.frame.panel;
    lc.panel.add(lc.canvas, 0);
    lc.frame.setLocation(left, top);
    return lc.frame;
   }

  Object prim_findsprite(Object arg1, Object arg2, LContext lc){
    int x = Logo.anInt(arg1, lc), y = Logo.anInt(arg2, lc);
    Sprite s = lc.canvas.findSprite(x, y);
    if(s==null) return new Object[0];
    return s;
  }

  Object prim_newsprite(Object arg1, Object arg2, Object arg3, LContext lc){
    int x = Logo.anInt(arg2, lc), y = Logo.anInt(arg3, lc);
    return new Sprite((Shape)arg1, x, y, lc.canvas);
  }

  Object prim_newshape(Object arg1, LContext lc){
    String filename = Logo.aString(arg1, lc);
    URL u = SpriteFrame.class.getResource("images/" + filename);
    if (u == null) Logo.error("can't get shape "+filename, lc);
    Image img = Toolkit.getDefaultToolkit().getImage(u);
    MediaTracker mt = new MediaTracker(lc.frame);
    try {
      mt.addImage(img, 0);
      mt.waitForID(0);
    }
    catch(Exception e) {Logo.error("can't get shape "+" "+e+" "+filename, lc);}
    return new Shape(img, true);
  }

Image getAnImage (String filename, LContext lc) {
     URL u = SpriteFrame.class.getResource("images/" + filename);
     if (u == null) Logo.error("can't get shape "+filename, lc);
     Image img = Toolkit.getDefaultToolkit().getImage(u);
     MediaTracker mt = new MediaTracker(lc.frame);
     try {
       mt.addImage(img, 0);
       mt.waitForID(0);
     }
     catch(Exception e) {Logo.error("can't get shape "+" "+e+" "+filename, lc);}
     return img;
   }


  Object prim_talkto(Object arg1, LContext lc){
    if (emptyp(arg1)) who=null;
    else who = (Sprite)arg1;
    return null;
  }

  Object prim_ask(Object arg1, Object arg2, LContext lc){
    Object[] list;
    if(arg2 instanceof Symbol) {list=new Object[1]; list[0]=arg2;}
    else list = Logo.aList(arg2, lc);
    Sprite oldwho=who;
    try {
      if(arg1 instanceof Sprite){who=(Sprite)arg1; return Logo.runList(list, lc);}
      Object [] wholist = (Object[]) arg1;
      for(int i=0;i<wholist.length;i++){who=(Sprite)wholist[i]; Logo.runCommand(list, lc);}
    }
    finally {who=oldwho;}
    return null;
  }

  Object prim_who(LContext lc){
    if(who==null) return new Object[0];
    return who;
  }

  Object prim_setxy(Object arg1, Object arg2, LContext lc){
    int x = Logo.anInt(arg1, lc), y = Logo.anInt(arg2, lc);
    who.setxy(x, y);
    return null;
  }

  Object prim_setlabel(Object arg1, Object arg2, Object arg3,  Object arg4, LContext lc){
    String label = Logo.prs(arg1);
    int x = Logo.anInt(arg2, lc), y = Logo.anInt(arg3, lc);
    int rgb = Logo.anInt(arg4, lc);
    who.setlabel(label, x, y, rgb);
    return null;
  }


  Object prim_labelwidth(Object arg1, LContext lc){
    String str = Logo.prs(arg1);
    if (str.length() == 0) return new Double (0);
    return new Double (who.stringwidth(str));
   }


  Object prim_pixcolor(Object arg1, Object arg2, Object arg3, LContext lc){
    int x = Logo.anInt(arg2, lc), y = Logo.anInt(arg3, lc);
    if (arg1 instanceof Shape) return new Double(((Shape)arg1).pix[y*who.rect.width+x]);
    Mask m = (Mask)arg1;
    return new Double(m.pix[y*m.width+x]);
  }

 Object prim_shown(LContext lc){
   return new Boolean (who.shown);
  }

  Object prim_outsiderect(Object arg1, LContext lc){
    Object [] l = (Object[]) arg1;
    Rectangle r = new Rectangle(Logo.anInt(l[0], lc), Logo.anInt(l[1], lc),
                                Logo.anInt(l[2], lc), Logo.anInt(l[3], lc));
    return new Boolean(r.intersection(who.rect).isEmpty());
  }


  Object prim_rect(LContext lc){
    Object [] l = new Object[4];
    l[0] = new Double (who.rect.x);
    l[1] = new Double (who.rect.y);
    l[2] =  new Double (who.rect.width);
    l[3] =  new Double (who.rect.height);
    return l;
  }

  Object prim_spritelist (LContext lc) {
    Object [] result = new Object[lc.canvas.sprites.size()];
    for (int i = 0 ; i < result.length ; i++ )
      result[i] = lc.canvas.sprites.elementAt(i);
    return result;
  }

  boolean emptyp(Object x){return ((x instanceof Object[])&&(((Object[])x).length==0));}

  Object prim_newdynamicshape(Object arg1, Object arg2, LContext lc){
    int w = Logo.anInt(arg1, lc), h = Logo.anInt(arg2, lc);
   // Image img = lc.canvas.createImage(w,h);
    Image img = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
    return new Shape(img, false);
  }

  Object prim_drawinshape(Object arg0, Object arg1, Object arg2, Object arg3, LContext lc){
    Image dest = ((Shape)arg0).img;
    Image source= ((Shape)arg1).img;
    int left = Logo.anInt(arg2, lc), top = Logo.anInt(arg3, lc);
    int w = source.getWidth(null), h = source.getHeight(null);
    Graphics destg = dest.getGraphics();
    destg.setClip(left, top, w, h);
    destg.drawImage(source, left, top, null);
    destg.dispose();
    return null;
  }

  Object prim_paintinshape(Object arg0, Object arg1, Object arg2, LContext lc){
    Image dest = ((Shape)arg0).img;
    Object [] list= (Object[])Logo.aList(arg2, lc);
    int left = ((Double)list[0]).intValue(), top = ((Double)list[1]).intValue(),
           w = ((Double)list[2]).intValue(), h = ((Double)list[3]).intValue(),
         rgb = Logo.anInt(arg1, lc);
    Color c = new Color (rgb);
    Graphics destg = dest.getGraphics();
    destg.setClip(left, top, w, h);
    destg.setColor(c);
    destg.fillRect(left, top, w, h);
    destg.dispose();
    return null;
  }

  Object prim_clearshape(Object arg0, LContext lc){
    Image dest = ((Shape)arg0).img;
    int w = dest.getWidth(null), h = dest.getHeight(null);
    Graphics destg = dest.getGraphics();
    Color c = new Color (200, 218,255);
    destg.setColor(c);
    destg.fillRect(0, 0, w, h);
    destg.dispose();
    return null;
  }

  Object prim_writeinshape(Object arg0, Object arg1, Object arg2, Object arg3, Object arg4, LContext lc){
    Image dest = ((Shape)arg0).img;
    String str = Logo.aString(arg1, lc);
    int left = Logo.anInt(arg2, lc), top = Logo.anInt(arg3, lc), rgb = Logo.anInt(arg4, lc);
    Graphics destg = dest.getGraphics();
    Color c = new Color (rgb);
    destg.setColor(c);
    Font font = new Font("Arial", Font.BOLD, 10);
    destg.setFont(font);
    int fw = destg.getFontMetrics().stringWidth(str);
    destg.drawString(str, left - (fw/2), top);
    destg.dispose();
    return null;
  }


 Object prim_ptinshape(Object arg0, Object arg1, Object arg2, LContext lc){
    Shape shp = ((Shape)arg2);
    int x = Logo.anInt(arg0, lc), y = Logo.anInt(arg1, lc);
    boolean result = shp.ptInShape (x,y);
    return new Boolean (result);
  }

  Object prim_shapew(Object arg0, LContext lc){
    Image dest = ((Shape)arg0).img;
    return new Double (dest.getWidth(null));
  }

  Object prim_shapeh(Object arg0, LContext lc){
    Image dest = ((Shape)arg0).img;
    return new Double (dest.getHeight(null));
  }

  Object prim_newmask(Object arg0, Object arg1, LContext lc){
    int x = Logo.anInt(arg0, lc), y = Logo.anInt(arg1, lc);
    return new Mask (x,y);
  }

  Object prim_clearmask(Object arg0, LContext lc){
    Mask m = (Mask)arg0;
    for (int i = 0; i < m.width*m.height;i++) m.pix[i] = 0;
    return null;
  }

  Object prim_drawinmask(Object arg0, Object arg1, Object arg2, Object arg3, Object arg4, LContext lc){
    Mask m = (Mask)arg0;
    Shape s = (Shape)arg1;
    int offx = Logo.anInt(arg2, lc), offy = Logo.anInt(arg3, lc);
    byte index = (byte)Logo.anInt(arg4, lc);
    int sw = s.img.getWidth(null), sh = s.img.getHeight(null);
    for (int y = 0; y < sh; y++){
      for(int x = 0; x < sw; x++)
        if (s.pix[y*sw+x] != 0) m.pix[(offy+y)*m.width+offx+x] = index;
     }
    return null;
  }

  Object prim_settitle(Object arg0, LContext lc){
    String str = Logo.aString(arg0, lc);
    String tstr = "TurtleArt";
    if(TurtleArt.dpiscale!=2) tstr = tstr+"-"+TurtleArt.dpiscale+"x";
    if(TurtleArt.iccname!=null) tstr = tstr+" "+TurtleArt.iccname;
    lc.frame.setTitle (tstr+": " + str);
    return null;
  }


  Object prim_framesize(LContext lc){
    Object [] l = new Object[2];
    l[0] = new Double (lc.frame.getSize().getWidth());
    l[1] = new Double (lc.frame.getSize().getHeight());
    return l;
  }

  Object prim_validate( LContext lc){
    lc.panel.validate();
    return null;
  }

  Object prim_requestfocus(LContext lc){
    lc.canvas.requestFocus();
    return null;
  }

  Object prim_shapesize(Object arg0, LContext lc){
    Image img = ((Shape)arg0).img;
    Object [] l = new Object[2];
    l[0] = new Double (img.getWidth(null));
    l[1] = new Double (img.getHeight(null));
    return l;
  }

  Object prim_dolater(Object arg0, LContext lc){
    LogoCommandRunner cmd = new LogoCommandRunner(Logo.prs(arg0), lc, true);
    Timer timer = new Timer();
    timer.schedule(new DoLaterTask(cmd), 50);
    return null;
  }

  Object prim_shapefile(Object arg1, LContext lc){
    String filename = Logo.aString(arg1, lc);
    URL u = SpriteFrame.class.getResource("images/" + filename);
    return  new Boolean (u != null);
  }


  Object prim_setheading(Object arg1, LContext lc){
    who.setheading(Logo.aDouble(arg1, lc));
    return null;
  }

  Object prim_shadowshape(Object arg1, Object arg2, LContext lc){
    int shadowcolor = (int) Logo.aLong(arg2, lc);
    Image source = ((Shape)arg1).img;
    int w = source.getWidth(null), h = source.getHeight(null);
    BufferedImage dest = new BufferedImage(w, h, BufferedImage.TYPE_INT_ARGB);
    Graphics2D destg = (Graphics2D) dest.getGraphics();
    destg.setBackground(new Color(0, true));
    destg.clearRect(0, 0, w, h);
    destg.drawImage(source, 0, 0, null);
    destg.dispose();
    for (int y=0;y<h;y++){
      for (int x=0;x<w;x++) if(dest.getRGB(x,y)!=0) dest.setRGB(x, y, shadowcolor);
    }
    return new Shape(dest, false);
  }

  Object prim_showframe(Object arg1, LContext lc){
    SpriteFrame frame = ((SpriteFrame)arg1);
    if (emptyp(arg1)) return null;
    else  {frame.setVisible(true);
           frame.getContentPane().setLayout (null);}
    frame.setExtendedState (Frame.NORMAL);
    return null;
  }

  Object prim_hideframe(Object arg1, LContext lc){
    if (emptyp(arg1)) return null;
    else ((SpriteFrame)arg1).setVisible(false);
    return null;
  }

  //--------------------------------------
  // Splash prims
  //--------------------------------------

    Object prim_showsplash(Object arg1, Object arg2, Object arg3, LContext lc){
  String version = Logo.prs(arg1);
  int left = Logo.anInt(arg2, lc), top = Logo.anInt(arg3, lc);
    splashframe = new Splash("Hello TurtleArt", "splash.gif", "appicon.gif", version, left, top, lc);
    splashframe.setUndecorated(true);
    splashframe.centerIt();
    splashframe.setVisible(true);
    splashframe.toFront();
    splashframe.repaint();
    return null;
    }

    Object prim_hidesplash(LContext lc){
      if (emptyp(splashframe)) return null;
      else splashframe.setVisible(false);
      return null;
    }



  Object prim_setappicon(Object arg1, LContext lc){
    Image img= getAnImage(Logo.prs(arg1), lc);
    lc.frame.setIconImage (img);
    return null;
  }

}

class DoLaterTask extends TimerTask {

  LogoCommandRunner cmd;

  DoLaterTask(LogoCommandRunner cmd){
    super();
    this.cmd=cmd;
  }

  public void run() {
    SwingUtilities.invokeLater(cmd);
  }

}
