import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Component;
import java.awt.Cursor;
import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.font.TextLayout;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.image.BufferedImage;
import java.awt.Label;
import java.awt.MediaTracker;
import java.awt.Panel;
import java.awt.Point;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.awt.image.IndexColorModel;
import java.awt.image.PixelGrabber;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.MouseMotionListener;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.awt.event.ActionListener;
import java.awt.event.AdjustmentListener;
import java.awt.event.ActionEvent;
import java.awt.event.AdjustmentEvent;
import java.awt.event.ComponentListener;
import java.awt.event.FocusListener;
import java.awt.event.ComponentEvent;
import java.awt.event.FocusEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.geom.AffineTransform;
import java.awt.geom.Point2D;
import java.awt.geom.Area;
import java.awt.RenderingHints;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.util.Enumeration;
import java.util.Timer;
import java.util.List;
import java.util.TimerTask;
import java.util.Vector;
import java.io.FilenameFilter;
import java.net.URL;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JComponent;
import javax.swing.SwingUtilities;
import javax.swing.TransferHandler;

import java.awt.datatransfer.StringSelection;
import java.awt.dnd.*;

class SpriteFrame extends JFrame implements ComponentListener, FocusListener {

//class SpriteFrame extends Frame implements java.io.FilenameFilter {

  SpritePanel panel;
  SpriteCanvas canvas;
  LogoCommandRunner runfocusGained;
  static SpriteFrame frame;
  boolean isactive = false;
  LContext lc;
  Timer timer;
  double wscale = 1.0;
//  double wscale = 0.8;

  SpriteFrame(int w, int h, LContext lc){
    super("TurtleArt");
    frame = this;
    this.lc=lc;
//    Toolkit toolkit = Toolkit.getDefaultToolkit();
//    Dimension screenSize = toolkit.getScreenSize();
//    System.out.println(screenSize);
    panel = new SpritePanel (w, h, wscale, lc);
    Color c = new Color (200, 218,255);
    setBackground(c);
    setResizable(false);
    setDefaultCloseOperation (DO_NOTHING_ON_CLOSE);
    runfocusGained = new LogoCommandRunner("focusGained 0 0", lc, true);
    timer = new Timer();
    timer.scheduleAtFixedRate(new TickTask(lc), 2000, 50);
 }

  public void addNotify(){
    super.addNotify();
    getContentPane().add("Center", panel);
    addComponentListener (this);
    addWindowListener(new ToplevelWindowListener(lc));
    pack();
  }

 Image loadImage (String filename, LContext lc) {
    URL u = SpriteFrame.class.getResource("images/" + filename);
    if (u == null) Logo.error("can't get image "+filename, lc);
    Image res = Toolkit.getDefaultToolkit().getImage(u);
    MediaTracker mt = new MediaTracker(this);
    try {
       mt.addImage(res, 0);
       mt.waitForID(0);
    }
    catch(Exception e) {Logo.error("can't get image "+" "+e+" "+filename, lc);}
    return res;
  }

  void runfocusEvent(LogoCommandRunner l, FocusEvent e, boolean gained){
    l.listtorun[1] = e.getSource();
    l.listtorun[2] = new Boolean(gained);
    l.run();
  }

  public void componentResized(ComponentEvent e) {}
  public void componentHidden(ComponentEvent e) {}
  public void componentMoved(ComponentEvent e) {}
  public void componentShown(ComponentEvent e) {}

  public void focusGained(FocusEvent e) {
    runfocusEvent (runfocusGained, e, true);
    }
  public void focusLost(FocusEvent e) {
    runfocusEvent (runfocusGained, e, false);
    }
}


class SpritePanel extends JPanel {
  int width, height;
  LContext lc;

  SpritePanel(int w, int h, double s, LContext lc){
    this.lc=lc;
    width=(int)(w*s); height=(int)(h*s);
    setLayout (null);
    }

public boolean isOptimizedDrawingEnabled() {return false;}
public Dimension getPreferredSize(){return new Dimension(width, height);}
public Dimension getMinimumSize(){return new Dimension(width, height);}


}

class SpriteCanvas extends JPanel
      implements MouseListener, MouseMotionListener, KeyListener, AdjustmentListener,
                 DragGestureListener, DragSourceMotionListener, DragSourceListener,
                 DropTargetListener {
  int width, height, bgx, bgy, bgw, bgh,maskx=0, masky=0;
  Rectangle bgrect  = new Rectangle();
  BufferedImage offscreen, bg;
  Vector<Object> sprites = new Vector<Object>();
  LContext lc;

	DragSource dragSource;
	DropTarget dropTarget;
	DragGestureRecognizer dragGestureRecognizer;
	String dragtext = "";
	boolean dragging;
	boolean antialias = true;
	Cursor dragsavecursor;

  LogoCommandRunner runmousedragged,runmousemoved, runmouseclicked, runmousepressed, runmousereleased,
                runkeytyped,runkeypressed, runkeyreleased, scrolladjustment;
  Rectangle invalrect = new Rectangle();
  AffineTransform trans;

  SpriteCanvas(int w, int h, LContext lc){
    this.lc=lc;
    width=w; height=h;
    double s = lc.frame.wscale;
    setSize((int)(w*s), (int)(h*s));
    runmousedragged = new LogoCommandRunner("%mousedragged 0 0", lc, true);
    runmousemoved = new LogoCommandRunner("%mousemoved 0 0", lc, true);
    runmouseclicked = new LogoCommandRunner("%mouseclicked 0 0", lc, true);
    runmousepressed = new LogoCommandRunner("%mousepressed 0 0", lc, true);
    runmousereleased = new LogoCommandRunner("%mousereleased 0 0", lc, true);
    runkeytyped = new LogoCommandRunner ("keytyped 0 0", lc, true);
    runkeypressed = new LogoCommandRunner ("keypressed", lc, true);
    runkeyreleased = new LogoCommandRunner ("keyreleased", lc, true);
    scrolladjustment = new LogoCommandRunner ("scrollchanged 0 0", lc, true);
  }

  public void addNotify(){
    super.addNotify();
    offscreen = (BufferedImage)createImage(width, height);
    addMouseListener(this);
    addMouseMotionListener(this);
    addKeyListener(this);
    inval(new Rectangle(0, 0, width, height));
    if(System.getProperty("os.name").toLowerCase().startsWith("windows")){
	    dragSource = DragSource.getDefaultDragSource();
	    dragGestureRecognizer = dragSource.createDefaultDragGestureRecognizer(this, DnDConstants.ACTION_COPY , this);
	    dragSource.addDragSourceMotionListener(this);
	    dragSource.addDragSourceListener(this);
	  }
    dropTarget = new DropTarget(this,this);
    grabFocus();
    redraw();
  }


  void createBg(int x, int y, int w, int h) {
    int dpis = TurtleArt.dpiscale;
    bgx=x; bgy=y; bgw=w; bgh=h;
    bgrect = new Rectangle(x,y,w,h);
    bg = new BufferedImage(w*dpis, h*dpis, BufferedImage.TYPE_INT_RGB);
    Graphics offg = bg.getGraphics();
    Color c = new Color (200, 218,255);
    offg.setColor(c);
    offg.fillRect(0, 0, 50000, 50000);
    offg.dispose();
    trans = AffineTransform.getTranslateInstance(bgx,bgy);
    trans.scale(1.0/dpis,1.0/dpis);
  }

  void setMask(int x, int y) {
		maskx = x;
		masky = y;
		redraw(new Rectangle(bgx,bgy,bgw,bgh));
	}

  void inval(Rectangle r){
		if(r.isEmpty()) return;
    if(invalrect.isEmpty()) invalrect = new Rectangle(r);
    else invalrect = invalrect.union(r);
  }

  public void redraw() {
    redraw(invalrect);
  }

  void redraw(Rectangle r){
		if(r.isEmpty()) return;
		double s = lc.frame.wscale;
		repaint(new Rectangle((int)(r.x*s),(int)(r.y*s),(int)(r.width*s+2), (int)(r.height*s+2)));
		invalrect=new Rectangle();
	}

  public void paintComponent(Graphics gin){
    synchronized(this){
			AffineTransform oldt=null;
			Graphics2D g = (Graphics2D) gin;
			double s = lc.frame.wscale;
			Rectangle r = g.getClipBounds();
			if(s!=1.0){
				oldt = g.getTransform();
				g.scale(s, s);
				r = g.getClipBounds();
				boolean justbg = r.union(bgrect).equals(bgrect);
				if (antialias || !justbg){
			    g.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
			    g.setRenderingHint(RenderingHints.KEY_RENDERING, RenderingHints.VALUE_RENDER_QUALITY);
			    g.setRenderingHint(RenderingHints.KEY_INTERPOLATION, RenderingHints.VALUE_INTERPOLATION_BICUBIC);
				}
			}
			Graphics2D offg = (Graphics2D)offscreen.getGraphics();
			offg.setClip(r.x, r.y, r.width, r.height);
			if(bg!=null) offg.drawImage(bg, trans, null);
			offg.setColor(new Color(128,128,128,128));
			Area biga = new Area(new Rectangle(bgx,bgy,bgw,bgh));
			Area smalla = new Area(new Rectangle(bgx+maskx,bgy+masky,bgw-2*maskx,bgh-2*masky));
			biga.subtract(smalla);
			offg.fill(biga);
			for (int i=sprites.size()-1;i>=0;i--){
				Sprite spr = (Sprite)sprites.elementAt(i);
				if(r.intersects(spr.rect)) spr.paint(offg);
			}
			offg.dispose();
      g.drawImage(offscreen, 0, 0, width, height, this);
      if(oldt!=null) g.setTransform(oldt);
    }
  }

  void setLayer(int layer, Sprite spr){
    sprites.remove(spr);
    for (int i = 0 ; i < sprites.size() ; i++ ){
      Sprite s = (Sprite)sprites.elementAt(i);
      if (spr.layer <= s.layer)
        {sprites.add (i, spr) ;
         return;}
      }
    sprites.add (sprites.size(), spr);
  }

  Sprite findSprite(int x, int y){
    for (Enumeration e = sprites.elements() ; e.hasMoreElements() ;){
      Sprite s = (Sprite)e.nextElement();
      if (s.contains(x, y)) return s;
      }
    return null;
  }

  void setCursorNumber (int type){
  Cursor c = null ;
  if (type == 0 )  c= new Cursor(Cursor.DEFAULT_CURSOR);
  if (type == 1 ) c = new Cursor(Cursor.HAND_CURSOR) ;
  if (type == 2 ) c= new Cursor(Cursor.TEXT_CURSOR);
  if (type == 3 ) c= new Cursor(Cursor.MOVE_CURSOR);
  if (type == 4 ) c= new Cursor(Cursor.CROSSHAIR_CURSOR);
  if (type == 5 ) c= new Cursor(Cursor.WAIT_CURSOR);
  if (c == null) c= new Cursor(Cursor.DEFAULT_CURSOR);
  setCursor(c);
  }

 public Cursor createCursor (Image cursor, Point hotSpot, String name) {
   return Toolkit.getDefaultToolkit().createCustomCursor(cursor, hotSpot, name);
 }

  void runMouseEvent(LogoCommandRunner l, MouseEvent e){
    l.listtorun[1] = new Integer(e.getX());
    l.listtorun[2] = new Integer(e.getY());
    l.run();
  }

  void runKeyEvent(LogoCommandRunner l, KeyEvent e){
    l.listtorun[1] = new Integer(e.getKeyChar());
    l.listtorun[2] = new Integer(e.getModifiers());
    l.run();
  }

  public void mouseDragged(MouseEvent e){
		runMouseEvent(runmousedragged, e);
	}

  public void mouseMoved(MouseEvent e){
    lc.shiftdown = e.isShiftDown();
    if(System.getProperty("os.name").toLowerCase().startsWith("windows"))
     lc.controldown = e.isControlDown();
    else lc.controldown =  e.isMetaDown();
    runMouseEvent(runmousemoved, e);
  }

  public void mousePressed(MouseEvent e) {
		lc.clickcount=e.getClickCount();
    runMouseEvent(runmousepressed, e);
  }

  public void mouseClicked(MouseEvent e) {runMouseEvent(runmouseclicked, e);}
  public void mouseExited(MouseEvent e){}
  public void mouseEntered(MouseEvent e){}
  public void mouseReleased(MouseEvent e) {runMouseEvent(runmousereleased, e);}

  public Dimension getPreferredSize(){return new Dimension(width, height);}
  public Dimension getMinimumSize(){return new Dimension(width, height);}

  public void keyPressed (KeyEvent e){
    lc.shiftdown = e.isShiftDown();
    if(System.getProperty("os.name").toLowerCase().startsWith("windows"))
     lc.controldown = e.isControlDown();
    else lc.controldown =  e.isMetaDown();
    runkeypressed.run();
    }

  public void keyReleased (KeyEvent e){
    lc.shiftdown = e.isShiftDown();
    if(System.getProperty("os.name").toLowerCase().startsWith("windows"))
     lc.controldown = e.isControlDown();
    else lc.controldown =  e.isMetaDown();
    runkeyreleased.run();
    }

  public void keyTyped (KeyEvent e){runKeyEvent(runkeytyped, e);}

  public void adjustmentValueChanged(AdjustmentEvent e){
    Object [] listtorun = new Object [3];
    listtorun [0] = scrolladjustment.listtorun[0];
    listtorun[1] = e.getSource();
    listtorun[2] = new Integer(e.getValue());
    LogoCommandRunner cmd = new LogoCommandRunner(listtorun, lc, true);
    SwingUtilities.invokeLater(cmd);
  }

	public void dragGestureRecognized(DragGestureEvent event) {
		if(dragtext.equals("")) return;
		dragsavecursor = getCursor();
		dragSource.startDrag(event,getCursor(), new StringSelection(dragtext), null);
		dragging = true;
	}

	public void dragMouseMoved(DragSourceDragEvent e){runDragEvent(e, runmousedragged);}
	public void dragDropEnd(DragSourceDropEvent e){dragging = false; runDragEvent(e, runmousereleased);}

	public void runDragEvent(DragSourceEvent e, LogoCommandRunner l){
		Point p = e.getLocation();
		int left = (int)getLocationOnScreen().getX();
		int top = (int)getLocationOnScreen().getY();
		p.translate(-left,-top);
    l.listtorun[1] = new Integer((int)p.getX());
    l.listtorun[2] = new Integer((int)p.getY());
    l.run();
	}


	public void dragEnter(DragSourceDragEvent e){
		e.getDragSourceContext().setCursor(dragsavecursor);
	}

	public void dragExit(DragSourceEvent e){
		e.getDragSourceContext().setCursor(null);
	}

	public void dragOver(DragSourceDragEvent e){}
	public void dropActionChanged(DragSourceDragEvent e){}

    public void drop(DropTargetDropEvent e){
		Transferable t = e.getTransferable();
    try {
			e.acceptDrop(e.getDropAction());
			if(dragging) {e.dropComplete(true); return;}
			Object str = null;
			LogoCommandRunner cmd = null;
			Point p = e.getLocation();
			DataFlavor urlFlavor = new DataFlavor ("application/x-java-url; class=java.net.URL");
			if (t.isDataFlavorSupported(urlFlavor)){
			  try {str = t.getTransferData(urlFlavor);} catch (Exception ex) {}
			  if(str==null) str = t.getTransferData(DataFlavor.stringFlavor);
			  cmd = new LogoCommandRunner("drop-text ["+str+"] "+p.getX()+" "+p.getY(), lc, true);
			} else if (t.isDataFlavorSupported(DataFlavor.stringFlavor)){
			  str = t.getTransferData(DataFlavor.stringFlavor);
			  cmd = new LogoCommandRunner("drop-text ["+str+"] "+p.getX()+" "+p.getY(), lc, true);
			} else if(t.isDataFlavorSupported(DataFlavor.javaFileListFlavor)){
			  str = ((List)t.getTransferData(DataFlavor.javaFileListFlavor)).get(0);
			  cmd = new LogoCommandRunner("drop-file \"|"+str+"| "+p.getX()+" "+p.getY(), lc, true);
			}
			e.dropComplete(true);
			Timer timer = new Timer();
			timer.schedule(new DoLaterTask(cmd), 50);}
    catch (Exception ex) {System.out.println(ex);}
  }

 	public void dragEnter(DropTargetDragEvent e){}
  public void dragExit(DropTargetEvent e){}
  public void dragOver(DropTargetDragEvent e){}
  public void dropActionChanged(DropTargetDragEvent e){}
}


class Sprite {
  Rectangle rect=new Rectangle();
  SpriteCanvas canvas;
  Shape shape;
  int layer=0, strx = 0, stry = 0;
  boolean shown=false;
  Color lcolor;
  String label = null;
  Font font;
  double heading;

  Sprite(Shape shape, int x, int y, SpriteCanvas canvas){
    this.shape=shape;
    this.canvas=canvas;
//    canvas.sprites.add(0, this);
    rect=new Rectangle(x, y, shape.img.getWidth(null), shape.img.getHeight(null));
    font = new Font("Arial", Font.BOLD, 10);

//    setxy(x, y);
  }

  void setxy(int x, int y){
    synchronized(canvas){
    inval();
    rect=new Rectangle(x, y, shape.img.getWidth(null), shape.img.getHeight(null));
    inval(); redraw();
    }
  }

  void tsetxy(int x, int y){
    synchronized(canvas){
			int w=shape.img.getWidth(null),h=shape.img.getHeight(null);
			canvas.inval(rect.intersection(canvas.bgrect));
			rect=new Rectangle(x+canvas.bgx, y+canvas.bgy,w,h);
			canvas.inval(rect.intersection(canvas.bgrect));
			canvas.redraw();
    }
  }

  void setheading(double theta){
    heading=theta;
		canvas.inval(rect.intersection(canvas.bgrect));
		canvas.redraw();
  }


  void setlabel(String label, int x, int y, int rgb){
    this.label = label;
    strx = x;
    stry = y;
    lcolor = new Color (rgb);
    inval(); redraw();
  }

  double stringwidth(String str){
   Graphics2D g = (Graphics2D) canvas.getGraphics();
   TextLayout tl = new TextLayout (str,font, g.getFontRenderContext());
   Rectangle r = tl.getBounds().getBounds();
//   System.out.println (str + " Rect2D width: " + r.getWidth() );
   g.dispose();
   return r.getWidth();
   }


  void setshape(Shape shp){
    inval();
    shape=shp;
    inval(); redraw();
  }

  void setlayer(int layer){
    this.layer=layer;
    if(!shown) return;
    canvas.setLayer(layer, this);
    inval(); redraw();
  }

  void hide(){
    inval();
    canvas.sprites.remove(this);
    redraw();
    shown=false;
  }

  void show(){
    shown=true;
    canvas.setLayer(layer, this);
    inval(); redraw();
  }

  void paint(Graphics2D g){
   if (heading==0f) g.drawImage(shape.img, rect.x, rect.y, null);
   else {
     AffineTransform t = AffineTransform.getRotateInstance(heading*3.14159f/180f,
                                       (double)(rect.x+ 20), (double)(rect.y+20));
     t.translate((double)rect.x, (double)rect.y);
     g.drawImage(shape.img, t, null);
   }
   if (label != null)
      {g.setColor(lcolor);
       g.setFont(font);
        int y=rect.y;
        int w = g.getFontMetrics().stringWidth(label);
        g.drawString(label, rect.x+strx+(rect.width-w)/2, y+stry);
      }
  }

  boolean contains(int x, int y){
    if(!rect.contains(new Point(x, y))) return false;
    int dx=x-rect.x, dy=y-rect.y;
    if(heading!=0f){
      AffineTransform t = AffineTransform.getRotateInstance(-heading*3.14159f/180f, 20f, 20f);
      Point2D p = t.transform(new Point2D.Double((double)dx, (double)dy), null);
      dx=(int)p.getX(); dy=(int)p.getY();
    }
    if (shape.isTransparent(dx, dy)) return false;
    return true;
  }


  void inval () {
    if (shown) canvas.inval(rect);
  }

  void redraw () {
    if (shown) canvas.redraw();
  }

}


class Shape {
  byte[] pix;
  byte bgcolor;
  Image img;
  boolean opaque;

  Shape(Image img, boolean needpix){
    this.img=img;
    if (!needpix) return;
    PixelGrabber pg = new PixelGrabber(img, 0, 0, img.getWidth(null), img.getHeight(null), false);
    try{pg.grabPixels();}
    catch(Exception e){System.out.println(e);}
    pix = (byte[])pg.getPixels();
    int trans = ((IndexColorModel)pg.getColorModel()).getTransparentPixel();
    opaque = trans == -1;
    bgcolor = (byte)trans;
  }

  boolean isTransparent(int x, int y){
    if (opaque) return false;
    if (pix == null) return false;
    return pix[img.getWidth(null)*y+x]==bgcolor;
  }

  boolean ptInShape (int x, int y){
    Rectangle rect = new Rectangle (0, 0, img.getWidth(null), img.getHeight(null));
    if (!rect.contains(x,y)) return false;
    return !isTransparent(x,y);
  }
}


class Mask {

  byte [] pix;
  int width, height;

  Mask (int w, int h) {
    width = w;
    height = h;
    pix = new byte [w * h];
  }
}

class Splash extends Frame implements MouseListener, FocusListener {
  Image splashImage;
  int width, height, placex, placey;
  LContext lc;
  Font font;
  Color stringcolor;
  String version;

  Splash(String name, String s, String iconf, String ver, int placex, int placey, LContext lc){
     super(name);
     this.lc = lc;
     this.version = ver;
     this.placex = placex;
     this.placey = placey;
     splashImage =loadImage (s);
     height= splashImage.getHeight(this);
     width= splashImage.getWidth(this);
     setSize(width, height);
     font = new Font("Verdana", Font.BOLD, 14);
     stringcolor = new Color (0x696969);
     Image img= loadImage(iconf);
	 setIconImage (img);

    }

    Image loadImage(String filename){
    URL u = Splash.class.getResource("images/" + filename);
    if (u == null) Logo.error("can't get image "+filename, lc);
    Image img = Toolkit.getDefaultToolkit().getImage(u);
      MediaTracker mt = new MediaTracker(this);
      try {
        mt.addImage(img, 0);
        mt.waitForID(0);
      }
      catch(Exception e) {System.out.println ("can't load image"+" "+e+" "+filename);}
      return img;
     }


  public void centerIt(){
    Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
    setBounds((screenSize.width-width)/2,
        (screenSize.height-height)/2,
        width,
        height);
  }

  public void addNotify(){
    super.addNotify();
    addMouseListener(this);
    addFocusListener(this);
    (new Timer()).schedule(
      new TimerTask(){public void run(){setVisible(false);}},
      4000);
    repaint(0, 0, width, height);
  }

  public void paint(Graphics g){
    g.drawImage(splashImage,0,0,null);
    g.setColor(stringcolor);
    g.setFont(font);
    g.drawString(version, placex, placey);
//     System.out.println ("paint done " + stringcolor + " " + version + "  " + placex + "  " + placey);
  }

  public void update(Graphics g){
    paint(g);
  }

  public void focusGained(FocusEvent e) {}
  public void focusLost(FocusEvent e) {setVisible(false);}

  public void mouseClicked(MouseEvent e){setVisible(false);}
  public void mouseExited(MouseEvent e){}
  public void mouseEntered(MouseEvent e){}
  public void mousePressed(MouseEvent e){}
  public void mouseReleased(MouseEvent e){}

}

class BlockHelp extends JFrame {

  HelpCanvas helpCanvas;
  int height, width;

  BlockHelp(Image img, LContext lc){
    super("Help");
    helpCanvas = new HelpCanvas(img, lc);
    setBackground(Color.white);
    setResizable(false);
  }

  public void addNotify(){
    super.addNotify();
    addWindowListener(new WindowAdapter() {
        public void windowClosing(WindowEvent e){
            dispose();
           }
     });
    getContentPane().add(helpCanvas, BorderLayout.CENTER);
    pack();
  }

Image loadImage(String filename, LContext lc){
    URL u = HelpCanvas.class.getResource("images/" + filename);
    if (u == null) Logo.error("can't load image "+filename, lc);
    Image img = Toolkit.getDefaultToolkit().getImage(u);
    MediaTracker mt = new MediaTracker(this);
    try {
      mt.addImage(img, 0);
      mt.waitForID(0);
    }
    catch(Exception e) {Logo.error("can't load image"+" "+e+" "+filename, lc);}
    return img;
  }
}

class HelpCanvas extends JPanel {
    Image img;
    int width, height;

  HelpCanvas(Image img, LContext lc){
    super();
    this.img = img;
    height= img.getHeight(this);
    width= img.getWidth(this);
    setSize(width, height);
    }

  public void addNotify(){
    super.addNotify();
   }

/*
  public void update(Graphics g){
    paint(g);
    }
*/

  public void paintComponent(Graphics g){
    super.paintComponent(g);
    g.drawImage(img, 0, 0, width, height, this);
    }

  public Dimension getPreferredSize(){return new Dimension(width, height);}
  public Dimension getMinimumSize(){return new Dimension(width, height);}

}

class TickTask extends TimerTask {

  LogoCommandRunner runticktask;

  TickTask(LContext lc){
    super();
    runticktask = new LogoCommandRunner("ticktask", lc, true);
    }

  public void run() {
       runticktask.run();
    }

}
